Description

org.kepler.build.Get.getModule(Module module) has special behavior when it comes across the modules with names: ptolemy,
ptolemy-8.0, and ptolemy-kepler-2.3. This seems to allow checking out a specific revision of pll from the ptll repository. | added
ptolemy-kepler-2.3, and not ptolemy-kepler-*, because for some reason ptolemy-kepler-2.2 has a "local" copy of ptll, and i don't want
to change how 2.2 works.

We'll have to revisit this for 2.4.

History

#1 - 07/24/2012 05:08 PM - jianwu jianwu

Hi Derik,

I changed the code locally from

"if (module.getName ().equals (Module.PTOLEMY) || module.getName () .equals (Module.PTOLEMY_8_0) || module.getName (

) .equals (Module.PTOLEMY_KEPLER_2_3))"
to be "if (module.getName () .startsWith (Module.PTOLEMY))".

With the changes, I think we do not need to change the code for each Kepler release. I think it is only used f
or module downloading when using the command like "ant change-to -Dsuite=kepler-2.3". My tests for it works.

Do you know whether it is used somewhere else?

#2 - 07/24/2012 06:10 PM - Derik Barseghian

That looks similar to the regex | mentioned | didn't use so as not to change the checkout behavior of ptolemy-kepler-2.2. If you make that change, and
someone tries to use 2.4 to checkout ptolemy-kepler-2.2, it will attempt to fetch it from the ptll repo and not ours, which is different to how things work
for 2.2.

Instead you'd need something like IPTOLEMY_KEPLER_2_2 && startsWith(PTOLEMY_KEPLER). It's debatable whether this is better or worse than
just appending one more fully specified PTOLEMY_KEPLER_2_4 variable.

If you do either of those, please don't close the bug, just push it back. The right solution is to remove as much behavior hardcoded to module names
as possible.

I'd definitely look around to see what all the other hardcoded uses of "ptolemy" are for. At 27924 and 27949 | put a lot of the hardcoded "ptolemy”
strings into variables, e.g. at the top of Module.java, so you can search your workspace for references to those.

#3 - 07/25/2012 11:27 AM - jianwu jianwu

Thanks Derik. | didn't know Kepler 2.2 has ptolemy branch (namely ptolemy-kepler-2.2) at kepler svn yet other Kepler versions have ptolemy branch
at ptolemy svn.

For Kepler 2.4, | think we will have ptolemy branch at ptolemy svn since Christopher said ptolemy will release a new version around the same time of
Kepler 2.4 release, and Kepler 2.4 will use this new ptolemy version. So either change solutions you mentioned for this bug are good for Kepler 2.4.

For future Kepler releases, Ptolemy may or may not have new releases/branches. We can discuss this issue during the next release meeting and
hopeful we can make a decision so this code does not need to be updated for every release.

If we decide to have a new Ptolemy branch at Ptolemy svn for each future Kepler release, we'd better use the condition like
IPTOLEMY_KEPLER_2_2 &&

startsWith(PTOLEMY_KEPLER). If we will have a new Ptolemy branch at Kepler svn for each future Kepler release, we'd better use the condition like
module.getName().equals(Module.PTOLEMY_KEPLER_2_3)) ||

module.getName().equals(Module.PTOLEMY_KEPLER_2_4). By this way, we can minimize the future changes for this class.

With current 4 release starting with Kepler 2.0, only Kepler 2.2 has ptolemy branch (namely ptolemy-kepler-2.2) at kepler svn. | don't know why. |
think a better solution is to have a new Ptolemy branch at Ptolemy svn for each future Kepler release.

| checked your changes at 27924 and 27949, and don't think we need further changes except this part.

#4 - 07/26/2012 01:51 PM - jianwu jianwu
| updated Get class at version 30290 using solution like IPTOLEMY_KEPLER_2_2 &&

startsWith(PTOLEMY_KEPLER). If we decide to go another way during the next release call, | can change it accordingly again.

#5 - 08/06/2012 12:07 PM - likay Altintas

We agree that we will have a special Ptolemy Il branch for each Kepler release. The branch should stay in the ptll release.

#6 - 03/27/2013 02:30 PM - Redmine Admin
Original Bugzilla ID was 5440
